using System;
using System.Windows.Forms;
using System.Drawing;
// compile: csc /t:winexe basicwinform.cs
class MyWinApp
{
  static void Main() 
  {
	  // (1) Create form and invoke it
	  Form mainForm = new SimpleForm();
	  Application.Run(mainForm);  
  }
}
// User Form derived from base class Form
class SimpleForm:Form
{
     private Button button1;
  	 public SimpleForm() 
  	 {
		 this.Text = "Hand Made Form";
		 // (2) Create a button control and set some attributes
		 button1 = new Button();
		 button1.Location = new Point(96,112);
		 button1.Size = new Size(72,24);
		 button1.Text= "Status";
		 this.Controls.Add(button1);  	  		
		 // (3) Create delegate to call routine when click occurs
		 button1.Click += new EventHandler(button1_Click);
  	 }
     void button1_Click(object sender, EventArgs e) 
     {
     	 MessageBox.Show("Up and Running");
     }   	
}
