using System;
using System.Windows.Forms;
using System.Drawing;
class MyWinApp
{
  static void Main() 
  {
      Application.Run(new SimpleForm());  
  }
}
// User Form derived from base class Form
class SimpleForm:Form
{
  public Panel pan;
  public SimpleForm() 
  {
	  this.Text = "Buffered Image Example";
	  this.Height = 200;
	  Button button1 = new Button(); 
	  button1.Location = new Point(46,122);
	  button1.Size = new Size(82,24);
	  button1.Text= "&Show Flag";
	  button1.Click += new EventHandler(button1_Click);  
	  this.Controls.Add(button1); 
	  
	  Button button3 = new Button();
	  button3.Location = new Point(146,122);
	  button3.Size = new Size(82,24);
	  button3.Text= "&Reverse";
	  this.Controls.Add(button3); 
	  button3.Click+= new EventHandler(button3_Click);
 
	  pan = new Panel();
	  pan.Location= new Point(60,20);
	  pan.Size= new Size(160,80);
	  this.Controls.Add(pan);
	  pan.BackColor=Color.White;
	  // Place flag in panel
	  string fname = "c:\\flag.gif";
	  Bitmap bmp = new Bitmap(fname);         
	  pan.BackgroundImage= bmp;    	  
  }
  
  private void button3_Click(object sender, EventArgs e)
  {
      // Reverse red and white pixels in image
      Graphics g = pan.CreateGraphics();
      int pHeight= pan.Height;
      int pWidth= pan.Width;
      string fname = "c:\\flag.gif";
      Bitmap bmp = new Bitmap(fname);         
      Bitmap bmpMem = new Bitmap(bmp.Width,bmp.Height);
      Graphics gMem = Graphics.FromImage(bmpMem); 
      gMem.DrawImage(bmp,0,0);
      Color cnRed = Color.FromArgb(255,214,41,33);
      for (int y=0; y<bmpMem.Height; y++)
      {
         for (int x=0; x<bmpMem.Width; x++)
         {          
            Color px = bmpMem.GetPixel(x,y);          
            if(px.G > 240) bmpMem.SetPixel(x,y, cnRed);
            else  
            bmpMem.SetPixel(x,y,Color.White);                  
         }    
      }    
      g.DrawImage(bmpMem,0,0);       
      gMem.Dispose();
      g.Dispose();    
  }
  
  
  void button1_Click(object sender, EventArgs e) 
  {
      // Draw original flag on panel
      Graphics g = pan.CreateGraphics();
	  int pHeight= pan.Height;
	  int pWidth= pan.Width;
	  string fname = "c:\\flag.gif";
      Bitmap bmp = new Bitmap(fname);    
      g.DrawImage(bmp,0,0);       
      g.Dispose();       
  }   	  
}