<?xml version="1.0"?>
<xsl:stylesheet version="1.0" 
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:template match="/">  
   <HTML>
     <TITLE>Movies</TITLE>
     <Table border="0" padding="3" cellspacing="2">
     <THEAD bgcolor="efefe4">  
       <TH>Movie Title</TH>
       <TH>Movie Year </TH>
       <TH>AFI Rank   </TH>
       <TH>Director   </TH>
     </THEAD>
     <xsl:for-each select="//movies">
       <xsl:sort select="movie_Title" />
       <tr>
         <td><xsl:value-of select="movie_Title"/> </td>
         <td align="center"><xsl:value-of select="movie_Year"/> </td>
         <td align="center"><xsl:value-of select="AFIRank" /></td>
         <td align="left"><xsl:value-of select="movie_Director" /></td>
        </tr>
      </xsl:for-each>
      </Table>
    </HTML>       
  </xsl:template>
</xsl:stylesheet>
