using System;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Http;
using System.Collections;
using System.Reflection;
using SimpleServer;   // namespace of server
// compile: csc /r:msgserver.dll msgclient.cs
[assembly: AssemblyVersion("1.0.0.0"), System.CLSCompliant(true)]
namespace SimpleClient
{
   // access remoting server
   public class MessageClient 
   {	
        private MessageClient() {}
	    static void Main(string[] args)
 	    {
 	  		string myID;
 	  		if(args.Length>0) myID= args[0]; else myID="001";
	  		Console.WriteLine("Client Started.");
	  		StartClient(myID);
		}
		private static void StartClient(string myID)
		{
	  		//RemotingConfiguration.Configure("msgclient.exe.config");      
	  		// Channel Registration
          	HttpChannel c = new HttpChannel();
	  		ChannelServices.RegisterChannel(c);
	  		// Type Registration
	  		Type ServerType = typeof(SimpleServer.MessageManager);
	  		// Activate Remote Object
		  	/*
			object remoteObj = Activator.GetObject(
						  ServerType,
						  "http://localhost:32469/MyObject");
		 	*/
	  		string url= "http://localhost:32469/MyObject";
	 		// SERVER Activation Mode
	  		RemotingConfiguration.RegisterWellKnownClientType(ServerType,url);
	  		// CLIENT Activation Mode
	  		//RemotingConfiguration.RegisterActivatedClientType(ServerType, url);
	
	  		//MessageManager mm = (MessageManager) remoteObj;    
  	 		MessageManager mm = new MessageManager();
	 		string msg;
	  		string oper="";
	 		try
	 		{
	  			while(oper !="Q") 
	  			{	
	   				 Console.WriteLine("(S)end, (R)eceive, (Q)uit");
	    			 oper= Console.ReadLine();
	    			 oper = oper.ToUpper();
	    			 if(oper=="S"){
	     			 Console.WriteLine("enter Recipient ID: messsage (ex. 007: Hello)");
	     			 msg= Console.ReadLine();
	     			 int ndx= msg.IndexOf(":");
	     			 if(ndx>0) 
	     			 {
	        			 string recipientID= msg.Substring(0,ndx).Trim();
	       				 msg= msg.Substring(ndx+1);
	        			 mm.SetMessage(msg, myID, recipientID);	
	      			 }
	     		     } else 
	     			 { 
	                     if (oper=="R")
	                     {	  
	          				 Console.WriteLine(mm.FetchMessages(myID));
	         			 }
	     			 }  
	    		} // while
	  		} catch (Exception ex) {Console.WriteLine(ex.Message);}  	   
	
		} // startclient
  	 }  // class
}     // namespace