using System;
using System.Collections;
using System.Reflection;
// compile: csc /t:library msgserver.cs
namespace SimpleServer
{
    // Message Server that manages client messaging
	public class MessageManager: MarshalByRefObject
	{
		ArrayList Messages = new ArrayList();
		public MessageManager()
		{
		    Console.WriteLine("Message Object Created.");  
		}
		public string RetrieveMessage(string clientID)
		{
		    return ("you have mail.");
		}
		public string FetchMessages(string clientID)
		{
		    string msgList= "";
		    Console.WriteLine(clientID);		
		    for (int i=Messages.Count-1;i>=0;i--)
		    {
		        Envelope env= (Envelope)Messages[i];
		        if(env.RecipientID== clientID)
		        {
		            msgList+= env.SenderID+": "+env.Message+"\n";
		            Messages.RemoveAt(i);
		        }
		    }
		    return(msgList);
		}
		
		public void SetMessage(string msg, string sender, string recipient)
		{
		    Envelope env= new Envelope();
		    env.Message= msg;
		    env.SenderID= sender;
		    env.RecipientID= recipient;
		    Messages.Add(env);
		    Console.WriteLine(msg);
		}
	}
    public class Envelope
    {
     	public string Message;
   	    public string SenderID;
   	    public string RecipientID;
    }
}