<%@ Page Language="C#"  %>
<script Language="C#" runat="Server">
  private void Page_Load(object sender, EventArgs e)
  {
     string fileRequest = Request.QueryString["file"];
     if(fileRequest!=null) 
     {
        // file is stored in directory of application
  	    string path = Server.MapPath(fileRequest);
  	    System.IO.FileInfo fi = new System.IO.FileInfo(path);
  	    if (fi.Exists) 
  	    {
  	       Response.ClearContent();
  	       Response.AppendHeader("Content-Disposition", "attachment;filename="+fi.Name);
  	       Response.AppendHeader("Content-Length",fi.Length.ToString());
  	       Response.ContentType="application/octet-stream";  //unknown media type
  	       // Write file to output stream
  	       Response.WriteFile(fi.FullName);
  	       Response.End(); 		
  	    }  else 
  	    {
  		   Response.Write(path+" does not exist.");
  	    }
  	
     } else 
     {  	
  	    Response.Write("No Download file was specified.");
  	 }
  }  
</script>