CREATE PROCEDURE SPMOVIES_LIST   
   @PageRequest int,
   @TotalPages int output
AS 
	/*
		Procedure to return a resultset of movies ordered by title. 
            Resultset contains 10 movies for the specified page.
  */
   SET NOCOUNT ON
   select @TotalPages = CEILING(COUNT(*)/10) from movies
   if @PageRequest = 1 or @PageRequest <1
   begin
   	select top 10 * from movies order by movie_Title
   	set @PageRequest = 1
   	return 0
   end   
   begin
         if @PageRequest > @TotalPages
               set @PageRequest = @TotalPages          
         declare @RowCount int
         set @RowCount = (@PageRequest * 10)
           
         exec ('SELECT * FROM
         (SELECT TOP 10 a.* FROM
         (SELECT TOP ' + @RowCount + ' * FROM movies ORDER BY 
               movie_Title) a
         ORDER BY movie_Title desc) b
         ORDER BY Movie_Title')        
           
         return 0
   end
