<%@ WebService Language="C#" Class="WSImages" %>
using System;
using System.Web.Services;
using System.IO;
using System.Web.Services.Protocols;
public class WSImages: System.Web.Services.WebService {
  [WebMethod(Description="Get an Image")]
  public byte[] GetImage(string imgName) {
    byte[] imgArray;
    imgArray = getBinaryFile("c:\\"+imgName+".gif");
    //throw new WebException("Could not open image file:"+imgName+".");
    if (imgArray.Length <2) 
    {
       throw new SoapException("Could not open image on server.",SoapException.ServerFaultCode);
    } else 
    {
        return(imgArray);
    }
 }
  public byte[] getBinaryFile(string filename) {
    if(File.Exists(filename)) {
      try {
         FileStream s=File.OpenRead(filename);
         return ConvertStreamToByteBuffer(s);
        } 
      catch(Exception e)
        {
         return new byte[0];
        }
    } else {
      return new byte[0];
    }
  }

  public byte[] ConvertStreamToByteBuffer(Stream imgStream) {
   int imgByte;
    MemoryStream tempStream = new MemoryStream();
    while((imgByte=imgStream.ReadByte())!=-1) {
      tempStream.WriteByte(((byte)imgByte));
    }
    return tempStream.ToArray();
  }
}
