using System;
using System.Runtime.Remoting;
using System.Collections;
using System.Drawing;
using System.IO;
using System.Runtime.Remoting.Lifetime;  // contains ILease
// compile: csc /t:library caoimageserver.cs
public class ImageServer: MarshalByRefObject 
{        
       // Return list of available images in an array
       public ArrayList GetFiles()
       {
          ArrayList a = new ArrayList();
          string dir=@"c:\images\";
          foreach(string fileName in Directory.GetFiles(dir))
          {
              int ndx= fileName.LastIndexOf("\\");
              string imgName = fileName.Substring(ndx+1);  // strip directory
       	      a.Add(imgName);       
          }       
          return a;      
       }		       
           
       // Return requested image as byte stream
       public byte[] GetMovieImage(string imageName)
       {
      	  	int imgByte;
      	  	imageName= "c:\\images\\"+imageName;
      	 	 FileStream s = File.OpenRead(imageName);
      	  	MemoryStream ms = new MemoryStream();
      	 	while((imgByte =s.ReadByte())!=-1)
      	  	{
			    ms.WriteByte(((byte)imgByte));
      	  	}
      	  return ms.ToArray();            
       }      
      
       // Add Image to image directory
       public bool AddImage(string imgName,byte[] bmp)
       {
       	   bool added=false;
      	   string dir="c:\\images\\";
      	   string fileName= dir+imgName;
      	   if(!File.Exists(fileName)) 
      	   {            	
      	       MemoryStream ms = new MemoryStream(bmp);
      	       Bitmap bm = new Bitmap(ms);
      	       bm.Save(fileName);    
      	       added=true;
      	   }
      	   return added;      	 
       }     
 }  