using System;
using System.Windows.Forms;
using System.Drawing;
class MyWinApp
{
  static void Main() 
  {
  	 // (1) Create form and invoke it
  	 Application.Run(new HelpForm());  
  }
}

class HelpForm:Form
{
  ToolTip toolTip1;
  public HelpForm() 
  {
  this.Text = "Star Search";
  this.Width=400;
  this.Height=220;
  // Place this in whatever directory you want
  this.BackgroundImage= new Bitmap(@"c:\dracoblack.gif");
    
  Label star = new Label();
  star.Location= new Point(285,22);
  star.Size= new Size(50,16);
  star.Text="Gianfar";
  star.Tag = "> Magnitude: 3.82\n> 330 Light Years";
  star.Font = new Font(star.Font, 
  star.Font.Style | FontStyle.Bold);
  this.Controls.Add(star);  
   toolTip1 = new ToolTip();
   toolTip1.AutoPopDelay= 1500;
   toolTip1.SetToolTip(star, star.Tag.ToString());
   
  Label star2 = new Label();
  star2.Location= new Point(285,115);
  star2.Size= new Size(60,16);
  star2.Text="Thuban";
  star2.Tag = "   Alpha Draconis\n> Magnitude: 3.67\n> 310 Light Years";
  star2.Font = new Font(star2.Font, 
  star2.Font.Style | FontStyle.Bold);
  this.Controls.Add(star2);
  ToolTip toolTip2 = new ToolTip();
  toolTip2.AutoPopDelay= 1500;
  toolTip2.SetToolTip(star2, star2.Tag.ToString());
  
  Label star3 = new Label();
  star3.Location= new Point(5,143);
  star3.Size= new Size(50,16);
  star3.Text="Etamin";
  star3.Tag="> Magnitude: 2.24\n> 148 Light Years";
  star3.Font = new Font(star3.Font, 
  star3.Font.Style | FontStyle.Bold);
  this.Controls.Add(star3);
  ToolTip toolTip3 = new ToolTip();
  toolTip3.AutoPopDelay= 1500;
  toolTip3.SetToolTip(star3, star3.Tag.ToString());
  //  Use these to implement custom popup window
  //  star.MouseHover  += new EventHandler(Star_Desc);
  //  star2.MouseHover += new EventHandler(Star_Desc);
  //  star3.MouseHover += new EventHandler(Star_Desc); 
}
  // The following two methods show an alternate way to 
  // handle mouseover. They display a custom form rather
  // than tootip.
  private void Star_Desc(object sender, EventArgs e)
  {
     Label currLbl = (Label)sender;
     messageWindow mw = new messageWindow();
     mw.FormBorderStyle = FormBorderStyle.None;
     mw.StartPosition= FormStartPosition.Manual;
     mw.Location = new Point(this.Location.X+currLbl.Location.X+10, this.Location.Y+currLbl.Location.Y-10);
     mw.desc.Text=currLbl.Tag.ToString();   
     mw.Show();  
  }
  class messageWindow : Form
  {
     public Panel p;
     public Label desc;
     public messageWindow ()
     {
        p = new Panel();
        p.AutoScroll=true;
        desc= new Label();
        desc.BorderStyle = BorderStyle.FixedSingle;
        desc.Width= 115;
        desc.Height=60;
        desc.Location= new Point(0,0);
        p.Controls.Add(desc);
        this.Controls.Add(p);              
        
        Timer msgTimer = new Timer();
        msgTimer.Enabled=true;
        msgTimer.Interval= 1500;  // milliseconds
        msgTimer.Tick += new EventHandler(msgTimer_Tick);
        this.Width= 115;
        this.Height= 30;
        this.BackColor= Color.Beige;
     }
      
       private void msgTimer_Tick(object senter, EventArgs e)
       {
         this.Close();
       }        
    }
}