#region Using directives
using System;
using System.Windows.Forms;
#endregion
namespace flowlayout
{
    public class Form1 : Form
    {
        public Form1()
        {
            // FlowLayout Example
            // This is not available in .NET 1.x 
            FlowLayoutPanel flp = new FlowLayoutPanel();
            Button Button1 = new Button();
            Button1.Size = new Size(40, 20);
            Button1.Text = "Button1";
			//
            Button Button2 = new Button();
            Button2.Size = new Size(40, 20);
            Button2.Text = "Button2";
            //
            Button Button3 = new Button();
            Button3.Size = new Size(60, 20);
            Button3.Text = "Button3";
            //
            TextBox tb = new TextBox;
            tb.Text = "TextBox";
            tb.Size= new Size(60,20);
            //
            flp.Controls.Add(fButton1);
            flp.Controls.Add(fButton2);
            flp.Controls.Add(tb);
            flp.Controls.Add(fButton3);
            //
            flp.FlowDirection = FlowDirection.LefttoRight;                
            this.Controls.Add(flp);     
            this.Text= "Flow Layout";
    	 }
     }
     
     static class Program
	 {
	      /// <summary>
	      /// The main entry point for the application.
	      /// </summary>	        
	      static void Main()
	      {
	          Application.Run(new Form1());
	      }
    }     
 }