using System;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Http;
using SimpleServer;   // namespace of server
// compile: csc /r:msgserver.dll msghost.cs
namespace SimpleHost
{
  public class MessageHost 
  {	
	static void Main(string[] args)
 	{
	    Console.WriteLine("Host Started.");
         
	    // Channel Registration
        HttpChannel c = new HttpChannel(32469);
	    ChannelServices.RegisterChannel(c);
	    // Type Registration
	    Type ServerType = typeof(SimpleServer.MessageManager);
	    RemotingConfiguration.RegisterWellKnownServiceType(
	        ServerType,    // Type of Object
 	        "MyObject",     // Arbitrary name 
	        WellKnownObjectMode.Singleton);
	  
	    //  RemotingConfiguration.Configure("msghost.exe.config");
	    Console.Read();
	}
  }
}