using System;	
	using System.Drawing;
	using System.Windows.Forms;
	public class ArtForm : Form
	{
	   private PictureBox bigPicture;
	   private PictureBox tn1;
	   private PictureBox tn2;
	   private PictureBox tn3;
	   private Button btnClear;		
         public ArtForm()
	   {			
		bigPicture = new PictureBox();
		bigPicture.BackColor=Color.White;
		tn1 = new PictureBox();
		tn2 = new PictureBox();
		tn3 = new PictureBox();
		btnClear = new Button();
		bigPicture.Location = new Point(90, 30);
		bigPicture.Name = "bigPicture";
		bigPicture.Size = new Size(160, 160);
		this.Controls.Add(bigPicture);
		// Define picturebox to hold first thumbnail image
		tn1.BorderStyle = BorderStyle.FixedSingle;
		tn1.Cursor = Cursors.Hand;
		tn1.Image = Image.FromFile("C:\\schiele1.jpg");
		tn1.Location = new Point(8, 16);
		tn1.Name = "tn1";
		tn1.Size = new Size(56, 56);
		tn1.SizeMode = PictureBoxSizeMode.StretchImage;
		this.Controls.Add(tn1);   
		// tn2
		// 
		tn2.BackColor = System.Drawing.Color.White;
		//tn2.BackgroundImage = ((System.Drawing.Bitmap)(resources.GetObject("tn2.BackgroundImage")));
		tn2.Image = Image.FromFile("C:\\schiele2.jpg");
		tn2.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
		tn2.Cursor = System.Windows.Forms.Cursors.Hand;
		tn2.Location = new System.Drawing.Point(8, 80);
		tn2.Name = "tn2";
		tn2.Size = new System.Drawing.Size(56, 56);
		tn2.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
		tn2.TabIndex = 2;
		tn2.TabStop = false;
		this.Controls.Add(tn2);   
		// 
		// tn3
		// 
		tn3.BackColor = System.Drawing.Color.White;
		tn3.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
		tn3.Cursor = System.Windows.Forms.Cursors.Hand;
		//tn3.Image = ((System.Drawing.Bitmap)(resources.GetObject("tn3.Image")));
		tn3.Location = new System.Drawing.Point(8, 144);
		tn3.Name = "tn3";
		tn3.Image = Image.FromFile("C:\\schiele3.jpg");
		tn3.Size = new System.Drawing.Size(56, 56);
		tn3.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
		tn3.TabIndex = 3;
		tn3.TabStop = false;		
		this.Controls.Add(tn3);   
		//
		btnClear.Location = new Point(136, 192);
		btnClear.Name = "btnClear";
		btnClear.Size = new Size(88, 24);
		btnClear.Text = "Clear Image";		 
		this.Controls.Add(btnClear); 
		this.Text= "Art Viewer";
		btnClear.Click += new EventHandler(this.btnClear_Click);
		// Set up event handlers for double click events.
		tn1.DoubleClick += new EventHandler(ShowPic);
		tn2.DoubleClick += new EventHandler(ShowPic);
		tn3.DoubleClick += new EventHandler(ShowPic);
	   }
       
	   private void btnClear_Click(object sender, EventArgs e)
	   {
		     bigPicture.Image = null;	// Clear image
	   }	
	   
	   private void ShowPic (object sender, EventArgs e)
	   {
		    // sender is thumbnail image that is double clicked.
		    bigPicture.Image = ((PictureBox) sender).Image;
	   }
	   
	   static void Main() 
	   {
		   Application.Run(new ArtForm());
	   }   	   
	   
	}
